-------- INIZJALIZOWANIE RZNYCH DANYCH GRY --------------------------------------
game = {} --- przetrzymywanie fukncji gry
terrain = {} --tereny
ter = {} -- array terenu
policzone = false ---- stopowanie loop'a
terrainInfo = ""

-------------------------------- LOVE FUNCTIONS ---------------------------------------
function love.update(dt)
	game.CheckCursorAllTime()
end

function love.load()
	game.InitializeTerrain()
end

function love.draw()
	
	love.graphics.setBackgroundColor(255,255,255)
	
	game.DrawTerrain()
	game.DrawHUD()
	
	
	
end
-------------------------- LOVE FUNCTIONS END -------------------------------------
function game.InitializeTerrain()

	print("------Initialising Terrain!------")
	
	for i=1,10 do
	
		ter[i] = {}
		ter[i][1] = i -- id terenu
		
		-- przydzielenie krolestwa
		ter[i][2] = 0
		ter[i][3] = {250,250,250}
		ter[i][5] = "Neutral"
		if i == 1 then
			ter[i][2] = 1
			ter[i][3] = {255,0,0}
			print("Added: Red kingdom")
			ter[i][5] = "Red"
		elseif i == 10 then
			ter[i][2] = 2
			ter[i][3] = {0,0,255}
			print("Added: Blue kingdom")
			ter[i][5] = "Blue"
		else
			print("Added: Neutral terrain")
		end
		
		---- koordy krolestwa
		ter[i][4] = i*128-128
		
		------------- USTAWIANIE ATRYBUTW -----------------
		
		randomAspect = love.math.random(1,5)
		if randomAspect == 1 then
			ter[i][6] = 5 ---------- money per turn from this territory
			ter[i][7] = "Dessert" -- type of territory
			ter[i][8] = "Sunny" -- standard weather
		elseif randomAspect == 2 then
			ter[i][6] = 10 ---------- money per turn from this territory
			ter[i][7] = "Flatlands" -- type of territory
			ter[i][8] = "Cloudy" -- standard weather
		elseif randomAspect == 3 then
			ter[i][6] = 15 ---------- money per turn from this territory
			ter[i][7] = "Hills" -- type of territory
			ter[i][8] = "Snowy" -- standard weather
		elseif randomAspect == 4 then
			ter[i][6] = 25 ---------- money per turn from this territory
			ter[i][7] = "Forest" -- type of territory
			ter[i][8] = "Rainy" -- standard weather
		elseif randomAspect == 5 then
			ter[i][6] = 35 ---------- money per turn from this territory
			ter[i][7] = "Mountains" -- type of territory
			ter[i][8] = "Cloudy" -- standard weather
		end
		
		if i == 1 then 
			ter[i][6] = 50 ---------- money per turn from this territory
			ter[i][7] = "Flatlands" -- type of territory
			ter[i][8] = "Sunny" -- standard weather
		end
		
		if i == 10 then
			ter[i][6] = 50 ---------- money per turn from this territory
			ter[i][7] = "Flatlands" -- type of territory
			ter[i][8] = "Sunny" -- standard weather
		end
		
		
		table.insert(terrain,ter[i])
	end
		
end	

function game.DrawTerrain()
	for i=1, #terrain do
		love.graphics.setColor(terrain[i][3][1],terrain[i][3][2],terrain[i][3][3])
		love.graphics.rectangle("fill", terrain[i][4], 0, 128, 620)
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("line", terrain[i][4], 0, 128, 620)
		if policzone == false then
			print("Drawed: " .. terrain[i][5] .. " terrain, with ID: "..terrain[i][1])
			if i == 10 then
				policzone = true
				print("------Terrain done!------")
			end
		end
	end
end

function game.DrawHUD()
	love.graphics.setColor(150,150,150)
	love.graphics.line(620,620, 1280,620)
	
	love.graphics.setColor(0,0,0)
	love.graphics.print(terrainInfo, 410, 635)
end

function game.CheckCursorAllTime(x,y)
	x, y = love.mouse.getPosition()
	for i=1, #terrain do
			if x >= terrain[i][4] and x <= terrain[i][4]+128 and y <= 620 then
				--print("ID Terenu: ".. terrain[i][1])
				terrainInfo = "ID: ".. terrain[i][1] .."   |   Owner: ".. terrain[i][5] .."   |   Gold per turn: " .. terrain[i][6] .. "   |   Weather: " .. terrain[i][7] .. " / " .. terrain[i][8]
			else
				terrainInfo = "Hover over the terrain to see info of it!"
			end	
	end
end
--[[
function love.mousepressed(x, y, key)
	if key == "l" then
		if x < 100 then 
			stateID = stateID-1
			if stateID < 0 then
				stateID = 2
			end
			print(stateID .. " Colors")
		elseif x > 1180 then
			stateID = stateID+1
			if stateID > 2 then
				stateID = 0
			end
			print(stateID .. " Colors")
		end
	end
end
]]--

